//Important
/*
   If file is stereo (channels = 2), still load only 1 channel in the buffer
  For sequences test on which core is the timer interrupt running

*/
//#include <mySD.h>
//#include "SD.h"
//#include "FS.h"
#include "SdFat.h"
#include "FreeStack.h"
#include "esp_task_wdt.h"

#include "SPI.h"

#include "driver/i2s.h"
#include "freertos/queue.h"
#include "variables.h"

SdFat sd;
SdFile file1;
SdFile file2;

#define SDSPEED SD_SCK_MHZ(20) // result: 101 tracks in 771 ms

//TaskHandle_t Task0;
TaskHandle_t Task1;

void TRIG1_INT() {
  rewind_1 = 1;
}

void setup() {
  Serial.begin(9600);

  pinMode(TRIG1, INPUT);
  pinMode(TRIG2, INPUT);

  pinMode(LED, OUTPUT);

  attachInterrupt(digitalPinToInterrupt(TRIG1), TRIG1_INT, RISING);

  if (!sd.begin(5, SDSPEED)) {
    Serial.println("Card Mount Failed");
    return;
  }

  sd_init_files();

  //initialize i2s with configurations above
  i2s_driver_install((i2s_port_t)i2s_num, &i2s_config, 0, NULL);
  i2s_set_pin((i2s_port_t)i2s_num, &pin_config);
  //set sample rates of i2s to sample rate of wav file
  i2s_set_sample_rates((i2s_port_t)i2s_num, 44100);

  delay(500);

  digitalWrite(LED, HIGH);
  delay(100);
  digitalWrite(LED, LOW);
  delay(100);

}

void loop() {
  if (rewind_1) {
    rewind_1 = 0;
    //if a trigger has been detected, jump back at the beginning of the data bytes
    //the file becomes then available again
    file1.seekSet(start_byte_1);
    file2.seekSet(start_byte_2);
  }

  if (file1.available()) {
    if (number_of_channels_1 == 2) {
      file1.read(buf1_a, 4);

      //Right channel only
      //data = data << 16;

      //Left channel only
      //data_1_32 = data_1_32 >> 16;
    }

    if (number_of_channels_1 == 1) {
      file1.read(buf1_a, 2);
      //Right channel only
      //data = data_1_16 << 16;

      //Left channel only
      //data = data16;
    }
  }

  if (file2.available()) {
    if (number_of_channels_2 == 2) {
      //file2.read(buf2_a, 4);

      //Right channel only
      //data = data << 16;

      //Left channel only
      //data_2_32 = data_2_32 >> 16;
    }

    if (number_of_channels_2 == 1) {
      //file2.read(buf2_a, 2);
      //Right channel only
      //data = data || data_2_16;

      //Left channel only
      //data = data16;
    }
  }

  data = buf1_a[0];
  data |= buf1_a[1] << 8;
  data |= buf1_a[2] << 16;
  data |= buf1_a[3] << 24;

  i2s_write_sample_nb(data);
}
